import string
import re
import sys
import math
import random

random.seed()

tot_any = 0
tot_roc = 0
tot_gas = 0
tot_ice = 0
tot_unk = 0
tot_mns = 0

def write_top_sysfile (outfile):
  tf = open('./pydata/sys_top.txt', 'r')

  for line in tf.readlines():
    outfile.write(line)

  outfile.write('\n')
  tf.close()

def write_bottom_sysfile (outfile):
  tf = open('./pydata/sys_bottom.txt', 'r')

  for line in tf.readlines():
    outfile.write(line)

  outfile.write('\n')
  tf.close()

def write_top_quadfile (outfile):
  tf = open('./pydata/quad_top.txt', 'r')

  for line in tf.readlines():
    outfile.write(line)

  outfile.write('\n')
  tf.close()

def write_bottom_quadfile (outfile):
  tf = open('./pydata/quad_bottom.txt', 'r')

  for line in tf.readlines():
    outfile.write(line)

  outfile.write('\n')
  tf.close()

def spaces (i):
  if i < 10:
    return '  '
  elif i < 100:
    return ' '
  else:
    return ''
# end spaces

def create_solar_system (outfile, num, planets, num_stars, num_asteroids, num_storms):
  global tot_any
  global tot_roc
  global tot_gas
  global tot_ice
  global tot_unk
  global tot_mns

  if num_stars == 'Red Giant':
    outfile.write('Name                                             := Red Giant System ' + str(num) + '\n')
    outfile.write('Description                                      := An old star system where the star has entered the red giant stage of its life.\n')
  elif num_stars == 'White Dwarf':
    outfile.write('Name                                             := White Dwarf System ' + str(num) + '\n')
    outfile.write('Description                                      := An ancient star system where the star has entered the white dwarf stage of its life.\n')
  elif num_stars == 'Neutron':
    outfile.write('Name                                             := Neutron Star System ' + str(num) + '\n')
    outfile.write('Description                                      := The remnants of a supernova.\n')
  elif num_stars == 'Rogue Gas Giant':
    outfile.write('Name                                             := Rogue Gas Giant ' + str(num) + '\n')
    outfile.write('Description                                      := A lone gas giant which has escaped its parent star.\n')
  elif num_stars < 1:
    outfile.write('Name                                             := Starless ' + str(num) + '\n')
    outfile.write('Description                                      := Starless system.\n')
  elif num_stars == 1:
    outfile.write('Name                                             := Standard ' + str(num) + '\n')
    outfile.write('Description                                      := Standard solar system.\n')
  elif num_stars == 2:
    outfile.write('Name                                             := Binary ' + str(num) + '\n')
    outfile.write('Description                                      := Binary solar system.\n')
  elif num_stars == 3:
    outfile.write('Name                                             := Trinary ' + str(num) + '\n')
    outfile.write('Description                                      := Trinary solar system.\n')
  elif num_stars == 4:
    outfile.write('Name                                             := Quaternary ' + str(num) + '\n')
    outfile.write('Description                                      := Quaternary solar system.\n')
  elif num_stars == 5:
    outfile.write('Name                                             := Quintuple ' + str(num) + '\n')
    outfile.write('Description                                      := Quintuple solar system.\n')
  else:
    outfile.write('Name                                             := Extra ' + str(num) + '\n')
    outfile.write('Description                                      := Extra solar system.\n')


  outfile.write('System Physical Type                             := Normal\n')
  outfile.write('Portrait Bitmap                                  := System_Normal' + str(((num-1) % 3) + 1) +'.bmp\n')
  outfile.write('Portrait Picture Index                           := ' + str(((num-1) % 3) + 1) + '\n')

  # Empires should only start in systems with 1 or 2 stars.
  if not isinstance(num_stars, int) or num_stars < 1 or num_stars > 3:
    outfile.write('Empires Can Start In                             := FALSE\n')
  else:
    outfile.write('Empires Can Start In                             := TRUE\n')

  outfile.write('Number of Abilities                              := 0\n')

  #  outfile.write('Ability 1 Type                                   := Movement Random\n')
  #  outfile.write('Ability 1 Description                            := All ships will be moved 2 sectors in a random direction each turn.\n')
  #  outfile.write('Ability 1 Scope                                  := System - All\n')
  #  outfile.write('Ability 1 Range Formula                          := 0\n')
  #  outfile.write('Ability 1 Amount 1 Formula                       := 2\n')
  #  outfile.write('Ability 1 Amount 2 Formula                       := 0\n')


  outfile.write('WP Stellar Abil Type                             := Normal Warp Point\n')
  outfile.write('WP Min Radius                                    := 360\n')
  outfile.write('WP Max Radius                                    := 400\n')
  outfile.write('Chance Type Used                                 := Standard\n')

  buf = ''

  i = 0

  if num_stars == 'Red Giant':
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'
    buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := Normal Star\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Star Red Giant\n'
    buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
    buf += 'Obj ' + str(i) + ' Age                                        := Any\n'
    buf += 'Obj ' + str(i) + ' Color                                      := Any\n'
    buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'
  elif num_stars == 'White Dwarf':
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'
    buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := Normal Star\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Star White Dwarf\n'
    buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
    buf += 'Obj ' + str(i) + ' Age                                        := Any\n'
    buf += 'Obj ' + str(i) + ' Color                                      := Any\n'
    buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'

    for j in range(5):
      i += 1
      buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'
      buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring 4\n'
      buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Protostar Storm\n'
      buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Nebulae 11\n'
      buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'

  elif num_stars == 'Neutron':
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'
    buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := Normal Star\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Star Neutron\n'
    buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
    buf += 'Obj ' + str(i) + ' Age                                        := Any\n'
    buf += 'Obj ' + str(i) + ' Color                                      := Any\n'
    buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'

  elif num_stars == 'Rogue Gas Giant':
    1

  else:
    itr = 0
    while itr < num_stars:
      i += 1
      buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'

      ability = "Normal Star"

      if num_stars == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
      elif num_stars == 2:
        ability = "Binary Star"

        if i == 1:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(2) + '\n'
        else:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-2) + '\n'
      elif num_stars == 3:
        ability = "Trinary Star"

        if i == 1:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(-2) + '\n'
        elif i == 2:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(2) + '\n'
        else:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(2) + '\n'
      elif num_stars == 4:
        ability = "Quaternary Star"

        if i == 1:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(2) + '\n'
        elif i == 2:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(-2) + '\n'
        elif i == 3:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(2) + '\n'
        else:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(-2) + '\n'
      elif num_stars == 5:
        ability = "Quintuple Star"

        if i == 1:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(2) + '\n'
        elif i == 2:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(-1) + '\n'
        elif i == 3:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(-4) + '\n'
        elif i == 4:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-4) + '\n'
        else:
          buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(-1) + '\n'

      buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := ' + ability + '\n'
      buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Any\n'
      buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
      buf += 'Obj ' + str(i) + ' Age                                        := Average\n'
      buf += 'Obj ' + str(i) + ' Color                                      := Any\n'
      buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'

      itr += 1

  itr = 0
  while itr < num_storms:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(7 + itr % 3) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Storm\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Medium\n'

    itr += 1

  itr = 0
  while itr < num_asteroids:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Asteroids\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(9 - int(itr / 2) % 3) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Asteroids\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

    itr += 1

  for p in planets:
    i += 1

    if p[1] == 'Any':
      any_tot += 1
    elif p[1] == 'Rock':
      tot_roc += 1
    elif p[1] == 'Gas Giant':
      tot_gas += 1
    elif p[1] == 'Ice':
      tot_ice += 1
    else:
      tot_unk += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(p[0]) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'

    # If we are creating a rogue gas giant system, make the main gas giant big.
    if num_stars == 'Rogue Gas Giant' and p[0] == 1 and p[1] == 'Gas Giant':
      if itr % 2 == 1:
        sz = 'Large'
      else:
        sz = 'Huge'
    else:
      sz = 'Any'

    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= ' + sz + '\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= ' + p[1] + '\n'

    # Generate moons, if necessary.
    pnum = i

    m = 0
    while m < p[2]:
      i += 1

      buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'


      if m > 2:
        ring = 3
      else:
        ring = 2

      # If we are creating a rogue gas giant system, moons should be farther out.
      if num_stars == 'Rogue Gas Giant' and p[0] == 1 and p[1] == 'Gas Giant':
        if m > 1:
          ring = 4
        else:
          ring = 3

      buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Offset ' + str(pnum) + ' Ring ' + str(ring) + '\n'
      #buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Same As ' + str(pnum) + '\n'
      buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
      buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Tiny\n'
      buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

      m += 1

      tot_mns += 1

      if m > 10:
        break
      # end while
  # end for

  outfile.write('Number of System Objs                            := '+ str(i) + '\n')

  outfile.write(buf)

  outfile.write('\n')
# end create_solar_system()

def create_nebulae (outfile, num, num_storms, storm_color):
  global tot_any
  global tot_roc
  global tot_gas
  global tot_ice
  global tot_unk
  global tot_mns

  outfile.write('Name                                             := Nebulae ' + str(num) + '\n')
  outfile.write('Description                                      := This system is composed of a large nebula.\n')

  outfile.write('System Physical Type                             := Nebulae\n')
  outfile.write('Portrait Bitmap                                  := System_Nebulae' + str(((num-1) % 6) + 1) +'.bmp\n')
  outfile.write('Portrait Picture Index                           := ' + str(10 + ((num-1) % 6) + 1) + '\n')
  outfile.write('Empires Can Start In                             := FALSE\n')

  if num == 1:
    outfile.write('Number of Abilities                              := 1\n')
    outfile.write('Ability 1 Type                                   := Sight Obscuration\n')
    outfile.write('Ability 1 Description                            := The [%ScopeSystemName%] system is opaque to basic scanners.\n')
    outfile.write('Ability 1 Scope                                  := System - All\n')
    outfile.write('Ability 1 Range Formula                          := 0\n')
    outfile.write('Ability 1 Amount 1 Formula                       := 8\n')
    outfile.write('Ability 1 Amount 2 Formula                       := 0\n')
  else:
    outfile.write('Number of Abilities                              := 1\n')
    outfile.write('Ability 1 Type                                   := Sight Obscuration\n')
    outfile.write('Ability 1 Description                            := The [%ScopeSystemName%] system is opaque to basic scanners.\n')
    outfile.write('Ability 1 Scope                                  := System - All\n')
    outfile.write('Ability 1 Range Formula                          := 0\n')
    outfile.write('Ability 1 Amount 1 Formula                       := 8\n')
    outfile.write('Ability 1 Amount 2 Formula                       := 0\n')

  outfile.write('WP Stellar Abil Type                             := Normal Warp Point\n')
  outfile.write('WP Min Radius                                    := 360\n')
  outfile.write('WP Max Radius                                    := 400\n')
  outfile.write('Chance Type Used                                 := Standard\n')

  # Color Chart
  # 1  - red
  # 2  - burnt orange
  # 3  - orange
  # 4  - yellow
  # 5  - yellow-green
  # 6  - green
  # 7  - cyan
  # 8  - blue
  # 9  - indigo
  # 10 - purple
  # 11 - white

  red = 1
  burnt_orange = 2
  orange = 3
  yellow = 4
  yellow_green = 5
  green = 6
  cyan = 7
  blue = 8
  indigo = 9
  purple = 10
  white = 11

  buf = ''

  i = 0
  num_rings = 9

  # n stores the sum of 1 to num_rings.
  n = 0.0

  # Build a list to store the accumulated storms in each ring.
  storms_in_ring = []
  for j in range(num_rings + 2):
    storms_in_ring.append(0)
    n += j

  if n > 2:
    n -= 1

  dbg = 0

  # offset the ring storms are positioned in by this amount. intended to keep
  # storms out of the center hex.
  neb_offset = 2

  #itr serves as the index of the storm we are adding
  itr = 0
  while itr < num_storms:
    if dbg == 1:
      print '---------------------------------------'
      print 'storm ' + str(itr)

    position = neb_offset
    # iterate over 2 to num_rings, so we dont consider ring 1
    for r in range(neb_offset, num_rings + neb_offset):
      if dbg == 1:
        print 'r: ' + str(r) + '; n: ' + str(n) + '; r/n*itr = ' + str(r/n*itr)
        print 'storms_in_ring[r] < (r / n) * itr: ' + str(storms_in_ring[r] < (r / n) * itr)

      # For the current ring, check to see if enough storms have already
      # been placed to get its fair share.
      if storms_in_ring[r] <= (r / n) * itr:
        position = r

    if dbg == 1:
      print 'final position: ' + str(position)

    storms_in_ring[position] += 1

    if dbg == 1:
      print 'storms_in_ring: ' + str(storms_in_ring)

    # write out the storm in ring "position"
    i += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'

    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(position) + '\n'

    this_storm_type = 'Nebula ' + str(storm_color) + ' Storm '

    #this_storm_type = 'Nebula ' + str(int(math.ceil(storm_color / 2.0))) + ' Storm'

    # Color Chart
    # 1  - red
    # 2  - burnt orange
    # 3  - orange
    # 4  - yellow
    # 5  - yellow-green
    # 6  - green
    # 7  - cyan
    # 8  - blue
    # 9  - indigo
    # 10 - purple
    # 11 - white

    # rainbow neb
    if storm_color == 1:
      loc_test = position - neb_offset

      if loc_test == 0:
        this_storm_color = red
      elif loc_test == 1:
        this_storm_color = burnt_orange
      elif loc_test == 2:
        this_storm_color = orange
      elif loc_test == 3:
        this_storm_color = yellow
      elif loc_test == 4:
        this_storm_color = yellow_green
      elif loc_test == 5:
        this_storm_color = green
      elif loc_test == 6:
        this_storm_color = cyan
      elif loc_test == 7:
        this_storm_color = blue
      elif loc_test == 8:
        this_storm_color = indigo
      else:
        this_storm_color = purple

    # green/blue
    elif storm_color == 2:
      loc_test = position - neb_offset

      colors = [blue, green]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # cyan/yellow_green
    elif storm_color == 3:
      loc_test = position - neb_offset

      colors = [cyan, yellow_green]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # blue/red
    elif storm_color == 4:
      loc_test = position - neb_offset

      colors = [red, blue]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # blue/indigo
    elif storm_color == 5:
      loc_test = position - neb_offset

      colors = [blue, indigo]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # purple/indigo
    elif storm_color == 6:
      loc_test = position - neb_offset

      colors = [purple, indigo]

      this_storm_color = colors[itr % len(colors)]

    # red/indigo
    elif storm_color == 7:
      loc_test = position - neb_offset

      colors = [red, indigo]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # yellow/blue
    elif storm_color == 8:
      loc_test = position - neb_offset

      colors = [yellow, blue]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # orange/yellow
    elif storm_color == 9:
      loc_test = position - neb_offset

      colors = [yellow, orange]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # orange/burnt_orange
    elif storm_color == 10:
      loc_test = position - neb_offset

      colors = [orange, burnt_orange]

      this_storm_color = colors[itr % len(colors)]

    # yellow/burnt_orange
    elif storm_color == 11:
      loc_test = position - neb_offset

      colors = [burnt_orange, yellow]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # white/blue
    elif storm_color == 12:
      loc_test = position - neb_offset

      colors = [white, blue]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # white/yellow
    elif storm_color == 13:
      loc_test = position - neb_offset

      colors = [white, yellow]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # green/red
    elif storm_color == 14:
      loc_test = position - neb_offset

      colors = [green, red]

      if loc_test <= num_rings * 0.25:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.75:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[itr % len(colors)]

    # green/yellow_green/yellow
    elif storm_color == 15:
      loc_test = position - neb_offset

      colors = [green, yellow_green, yellow]

      if loc_test <= num_rings * 0.33:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.67:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[1]

    # green/blue/yellow
    elif storm_color == 16:
      loc_test = position - neb_offset

      colors = [blue, green, yellow]

      if loc_test <= num_rings * 0.33:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.67:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[1]

    # green/blue/purple
    elif storm_color == 17:
      loc_test = position - neb_offset

      colors = [green, blue, purple]

      if loc_test <= num_rings * 0.33:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.67:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[1]

    # orange/yellow/burnt_orange
    elif storm_color == 18:
      loc_test = position - neb_offset

      colors = [burnt_orange, orange, yellow]

      if loc_test <= num_rings * 0.33:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.67:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[1]

    # orange/cyan/burnt_orange
    elif storm_color == 19:
      loc_test = position - neb_offset

      colors = [orange, cyan, burnt_orange]

      if loc_test <= num_rings * 0.33:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.67:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[1]

    # green/yellow_green/orange
    elif storm_color == 20:
      loc_test = position - neb_offset

      colors = [green, yellow_green, orange]

      if loc_test <= num_rings * 0.33:
        this_storm_color = colors[0]
      elif loc_test > num_rings * 0.67:
        this_storm_color = colors[-1]
      else:
        this_storm_color = colors[1]

    else:
      this_storm_color = (storm_color % 9) + 1

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= ' + this_storm_type + '\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Nebulae ' + str(this_storm_color) + '\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'

    itr += 1

  outfile.write('Number of System Objs                            := '+ str(i) + '\n')

  outfile.write(buf)

  outfile.write('\n')
# end create_nebulae()

def create_protostar (outfile, num, planets, num_stars, num_asteroids, num_storms, storm_color):
  global tot_any
  global tot_roc
  global tot_gas
  global tot_ice
  global tot_unk
  global tot_mns

  outfile.write('Name                                             := Protostar ' + str(num) + '\n')
  outfile.write('Description                                      := A gaseous cloud beginning to form into a star system, with only a few planets formed thus far.\n')

  outfile.write('System Physical Type                             := Nebulae\n')
  outfile.write('Portrait Bitmap                                  := System_Nebulae' + str(((num-1) % 6) + 1) +'.bmp\n')
  outfile.write('Portrait Picture Index                           := ' + str(10 + ((num-1) % 6) + 1) + '\n')
  outfile.write('Empires Can Start In                             := FALSE\n')
  outfile.write('Number of Abilities                              := 0\n')
  outfile.write('WP Stellar Abil Type                             := Normal Warp Point\n')
  outfile.write('WP Min Radius                                    := 360\n')
  outfile.write('WP Max Radius                                    := 400\n')
  outfile.write('Chance Type Used                                 := Standard\n')

  # Color Chart
  # 1  - red
  # 2  - burnt orange
  # 3  - orange
  # 4  - yellow
  # 5  - yellow-green
  # 6  - green
  # 7  - cyan
  # 8  - blue
  # 9  - indigo
  # 10 - purple
  # 11 - white

  red = 1
  burnt_orange = 2
  orange = 3
  yellow = 4
  yellow_green = 5
  green = 6
  cyan = 7
  blue = 8
  indigo = 9
  purple = 10
  white = 11

  buf = ''

  i = 0

  itr = 0
  while itr < num_stars:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'

    if num_stars == 1:
      buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
    elif num_stars == 2:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(2) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-2) + '\n'
    elif num_stars == 3:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(-3) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(3) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(3) + '\n'
    elif num_stars == 4:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(3) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(-3) + '\n'
      elif i == 3:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(3) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(-3) + '\n'
    elif num_stars == 5:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(2) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(0) + '\n'
      elif i == 3:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(-4) + '\n'
      elif i == 4:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-4) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(0) + '\n'

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := Normal Star\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Any\n'
    buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
    buf += 'Obj ' + str(i) + ' Age                                        := Average\n'

    if storm_color == green:
      buf += 'Obj ' + str(i) + ' Color                                      := Green\n'
    elif storm_color == orange:
      buf += 'Obj ' + str(i) + ' Color                                      := Orange\n'
    elif storm_color == yellow:
      buf += 'Obj ' + str(i) + ' Color                                      := Yellow\n'
    elif storm_color == blue:
      buf += 'Obj ' + str(i) + ' Color                                      := Blue\n'
    elif storm_color == red:
      buf += 'Obj ' + str(i) + ' Color                                      := Red\n'
    elif storm_color == white:
      buf += 'Obj ' + str(i) + ' Color                                      := White\n'
    elif storm_color == purple:
      buf += 'Obj ' + str(i) + ' Color                                      := Purple\n'
    else:
      buf += 'Obj ' + str(i) + ' Color                                      := Any\n'

    buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'

    itr += 1

  num_rings = 7

  # n stores the sum of 1 to num_rings.
  n = 0.0

  # Build a list to store the accumulated storms in each ring.
  storms_in_ring = []
  for j in range(num_rings + 3):
    storms_in_ring.append(0)
    n += j

  if n > 2:
    n -= 1

  dbg = 0

  #itr serves as the index of the storm we are adding
  itr = 0
  while itr < num_storms:
    if dbg == 1:
      print '---------------------------------------'
      print 'storm ' + str(itr)

    position = 3
    # iterate over 3 to num_rings, so we dont consider ring 1 or 2
    for r in range(3, num_rings + 3):
      if dbg == 1:
        print 'r: ' + str(r) + '; n: ' + str(n) + '; r/n*itr = ' + str(r/n*itr)
        print 'storms_in_ring[r] < (r / n) * itr: ' + str(storms_in_ring[r] < (r / n) * itr)

      # For the current ring, check to see if enough storms have already
      # been placed to get its fair share.
      if storms_in_ring[r] <= (r / n) * itr:
        position = r

    if dbg == 1:
      print 'final position: ' + str(position)

    storms_in_ring[position] += 1

    if dbg == 1:
      print 'storms_in_ring: ' + str(storms_in_ring)

    # write out the storm in ring "position"
    i += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'

    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(position) + '\n'

    this_storm_type = 'Protostar Storm'

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= ' + this_storm_type + '\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Nebulae ' + str(storm_color) + '\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'

    itr += 1

  itr = 0
  while itr < num_asteroids:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Asteroids\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring 9\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Asteroids\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

    itr += 1

  for p in planets:
    i += 1

    if p[1] == 'Any':
      any_tot += 1
    elif p[1] == 'Rock':
      tot_roc += 1
    elif p[1] == 'Gas Giant':
      tot_gas += 1
    elif p[1] == 'Ice':
      tot_ice += 1
    else:
      tot_unk += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(p[0]) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= ' + p[1] + '\n'

    # Generate moons, if necessary.
    pnum = i

    m = 0
    while m < p[2]:
      i += 1

      buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'

      if m > 4:
        ring = 3
      else:
        ring = 2

      buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Offset ' + str(pnum) + ' Ring ' + str(ring) + '\n'
      buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
      buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Tiny\n'
      buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

      m += 1

      tot_mns += 1

      if m > 10:
        break
      # end while
  # end for


  outfile.write('Number of System Objs                            := '+ str(i) + '\n')

  outfile.write(buf)

  outfile.write('\n')
# end create_protostar()

def create_asteroid_belt (outfile, num, planets, num_stars, num_asteroids, num_storms, num_huge_asteroids):
  global tot_any
  global tot_roc
  global tot_gas
  global tot_ice
  global tot_unk
  global tot_mns

  if num_stars < 1:
    outfile.write('Name                                             := Starless Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := An asteroid field in deep space.\n')
  elif num_stars == 1:
    outfile.write('Name                                             := Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := An asteroid belt around a failed star.\n')
  elif num_stars == 2:
    outfile.write('Name                                             := Binary Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := An asteroid belt around a binary star system.\n')
  elif num_stars == 3:
    outfile.write('Name                                             := Trinary Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := An asteroid belt around a trinary star system.\n')
  elif num_stars == 4:
    outfile.write('Name                                             := Quaternary Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := An asteroid belt around a quaternary star system.\n')
  elif num_stars == 5:
    outfile.write('Name                                             := Quintuple Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := An asteroid belt around a quintuple star system.\n')
  else:
    outfile.write('Name                                             := Extra Asteroid Belt ' + str(num) + '\n')
    outfile.write('Description                                      := Extra asteroid belt system.\n')


  outfile.write('System Physical Type                             := Normal\n')
  outfile.write('Portrait Bitmap                                  := System_AsteroidBelt.bmp\n')
  outfile.write('Portrait Picture Index                           := 6\n')
  outfile.write('Empires Can Start In                             := FALSE\n')
  outfile.write('Number of Abilities                              := 0\n')
  outfile.write('WP Stellar Abil Type                             := Normal Warp Point\n')
  outfile.write('WP Min Radius                                    := 360\n')
  outfile.write('WP Max Radius                                    := 400\n')
  outfile.write('Chance Type Used                                 := Standard\n')

  buf = ''

  i = 0

  itr = 0
  while itr < num_stars:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'

    if num_stars == 1:
      buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
    elif num_stars == 2:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(2) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-2) + '\n'
    elif num_stars == 3:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(-2) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(2) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(2) + '\n'
    elif num_stars == 4:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(2) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(-2) + '\n'
      elif i == 3:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(2) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(-2) + '\n'
    elif num_stars == 5:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(2) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(-1) + '\n'
      elif i == 3:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(-4) + '\n'
      elif i == 4:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-4) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(-1) + '\n'

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := Normal Star\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Star Brown Dwarf\n'
    buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
    buf += 'Obj ' + str(i) + ' Age                                        := Any\n'
    buf += 'Obj ' + str(i) + ' Color                                      := Any\n'
    buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'

    itr += 1

  itr = 0
  while itr < num_storms:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(9 + itr % 2) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Storm\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Medium\n'

    itr += 1

  first_ast = i + 1

  itr = 0
  while itr < num_asteroids:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Asteroids\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Circle Radius 200, 240\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Asteroids\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

    itr += 1

  last_ast = i

  itr = 0
  while itr < num_huge_asteroids:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'

    position = itr * ((last_ast - first_ast) / num_huge_asteroids) + first_ast

    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Same As ' + str(position) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Tiny\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= None\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

    itr += 1

  for p in planets:
    i += 1

    if p[1] == 'Any':
      any_tot += 1
    elif p[1] == 'Rock':
      tot_roc += 1
    elif p[1] == 'Gas Giant':
      tot_gas += 1
    elif p[1] == 'Ice':
      tot_ice += 1
    else:
      tot_unk += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(p[0]) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'

    sz = 'Any'

    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= ' + sz + '\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= ' + p[1] + '\n'

    # Generate moons, if necessary.
    pnum = i

    m = 0
    while m < p[2]:
      i += 1

      buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'


      if m > 2:
        ring = 3
      else:
        ring = 2

      # If we are creating a rogue gas giant system, moons should be farther out.
      if num_stars == 'Rogue Gas Giant' and p[0] == 1 and p[1] == 'Gas Giant':
        if m > 1:
          ring = 4
        else:
          ring = 3

      buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Offset ' + str(pnum) + ' Ring ' + str(ring) + '\n'
      #buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Same As ' + str(pnum) + '\n'
      buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
      buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Tiny\n'
      buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

      m += 1

      tot_mns += 1

      if m > 10:
        break
      # end while
  # end for

  outfile.write('Number of System Objs                            := '+ str(i) + '\n')

  outfile.write(buf)

  outfile.write('\n')
# end create_asteroid_belt()

def create_infestation (outfile, num, planets, num_stars, num_asteroids, num_storms, storm_color):
  global tot_any
  global tot_roc
  global tot_gas
  global tot_ice
  global tot_unk
  global tot_mns

  outfile.write('Name                                             := Organic Infestation ' + str(num) + '\n')
  outfile.write('Description                                      := A semi-sentient organic infestation is consuming this system.\n')

  outfile.write('System Physical Type                             := Normal\n')
  outfile.write('Portrait Bitmap                                  := System_Normal' + str(((num-1) % 3) + 1) +'.bmp\n')
  outfile.write('Portrait Picture Index                           := ' + str(((num-1) % 3) + 1) + '\n')
  outfile.write('Empires Can Start In                             := FALSE\n')
  outfile.write('Number of Abilities                              := 0\n')
  outfile.write('WP Stellar Abil Type                             := Normal Warp Point\n')
  outfile.write('WP Min Radius                                    := 360\n')
  outfile.write('WP Max Radius                                    := 400\n')
  outfile.write('Chance Type Used                                 := Standard\n')

  # Color Chart
  # 1  - red
  # 2  - burnt orange
  # 3  - orange
  # 4  - yellow
  # 5  - yellow-green
  # 6  - green
  # 7  - cyan
  # 8  - blue
  # 9  - indigo
  # 10 - purple
  # 11 - white

  red = 1
  burnt_orange = 2
  orange = 3
  yellow = 4
  yellow_green = 5
  green = 6
  cyan = 7
  blue = 8
  indigo = 9
  purple = 10
  white = 11

  buf = ''

  i = 0

  itr = 0
  while itr < num_stars:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                              := Star\n'

    if num_stars == 1:
      buf += 'Obj ' + str(i) + ' Position                                   := Ring 1\n'
    elif num_stars == 2:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(2) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-2) + '\n'
    elif num_stars == 3:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(-3) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(3) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(3) + '\n'
    elif num_stars == 4:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(3) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(-3) + '\n'
      elif i == 3:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(3) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(-3) + '\n'
    elif num_stars == 5:
      if i == 1:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(0) + ',' + str(2) + '\n'
      elif i == 2:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(3) + ',' + str(0) + '\n'
      elif i == 3:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(2) + ',' + str(-4) + '\n'
      elif i == 4:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-2) + ',' + str(-4) + '\n'
      else:
        buf += 'Obj ' + str(i) + ' Position                                   := Coord ' + str(-3) + ',' + str(0) + '\n'

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                          := Normal Star\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                  := Any\n'
    buf += 'Obj ' + str(i) + ' Size                                       := Any\n'
    buf += 'Obj ' + str(i) + ' Age                                        := Average\n'
    buf += 'Obj ' + str(i) + ' Color                                      := Any\n'
    buf += 'Obj ' + str(i) + ' Luminosity                                 := Any\n'

    itr += 1

  num_rings = 7

  # n stores the sum of 1 to num_rings.
  n = 0.0

  # Build a list to store the accumulated storms in each ring.
  storms_in_ring = []
  for j in range(num_rings + 3):
    storms_in_ring.append(0)
    n += j

  if n > 2:
    n -= 1

  dbg = 0

#  storm_locs = [[-2, 10], [2, 10], [0, 9], [-3, 7], [3, 7],
#
#                [-7, 6], [-4, 6], [-8, 5], [-8, 3], [-10, 3], [-9, 0],
#
#                [6, 6], [5, 7], [8, 5], [10, 3], [6, 4], [5, 2], [3, 1],
#                [11, 0], [10, -2], [8, -4],
#
#                [0, 6], [-6, 9], [6, 9]
#               ]
#
#  #itr serves as the index of the storm we are adding
#  itr = 0
#  while itr < num_storms and itr < len(storm_locs):
#    i += 1
#
#    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'
#
#    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Coord ' + str(storm_locs[itr][0]) + ', ' + str(storm_locs[itr][1]) + '\n'
#
#    this_storm_type = 'Infestation Storm'
#
#    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= ' + this_storm_type + '\n'
#    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Infestation ' + str((itr % 5) + 1) + '\n'
#    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
#
#    itr += 1

  if num_storms > 0:
    i += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring 3\n'

    this_storm_type = 'Infestation Storm'

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= ' + this_storm_type + '\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Infestation 1\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'

  #itr serves as the index of the storm we are adding
  itr = 1
  while itr < num_storms:
    i += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Storm\n'

    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Offset ' + str(i - 1) + ' Ring 4\n'

    this_storm_type = 'Infestation Storm'

    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= ' + this_storm_type + '\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Infestation ' + str((itr % 5) + 1) + '\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'

    itr += 1

  itr = 0
  while itr < num_asteroids:
    i += 1
    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Asteroids\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring 9\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Asteroids\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

    itr += 1

  for p in planets:
    i += 1

    if p[1] == 'Any':
      any_tot += 1
    elif p[1] == 'Rock':
      tot_roc += 1
    elif p[1] == 'Gas Giant':
      tot_gas += 1
    elif p[1] == 'Ice':
      tot_ice += 1
    else:
      tot_unk += 1

    buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'
    buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Ring ' + str(p[0]) + '\n'
    buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
    buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
    buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= ' + p[1] + '\n'

    # Generate moons, if necessary.
    pnum = i

    m = 0
    while m < p[2]:
      i += 1

      buf += 'Obj ' + str(i) + ' Physical Type                            ' + spaces(i) + ':= Planet\n'

      if m > 4:
        ring = 3
      else:
        ring = 2

      buf += 'Obj ' + str(i) + ' Position                                 ' + spaces(i) + ':= Offset ' + str(pnum) + ' Ring ' + str(ring) + '\n'
      buf += 'Obj ' + str(i) + ' Stellar Abil Type                        ' + spaces(i) + ':= Normal Planet\n'
      buf += 'Obj ' + str(i) + ' Specific Stellar Obj Name                ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Size                                     ' + spaces(i) + ':= Tiny\n'
      buf += 'Obj ' + str(i) + ' Atmosphere                               ' + spaces(i) + ':= Any\n'
      buf += 'Obj ' + str(i) + ' Composition                              ' + spaces(i) + ':= Any\n'

      m += 1

      tot_mns += 1

      if m > 10:
        break
      # end while
  # end for


  outfile.write('Number of System Objs                            := '+ str(i) + '\n')

  outfile.write(buf)

  outfile.write('\n')
# end create_infestation()

# chances array:
#   0 : expanse
#   1 : standard solar systems
#   2 : binary
#   3 : trinary
#   4 : quaternary
#   5 : quintuple
#   6 : nebulae
#   7 : black hole
#   8 : protostar
#   9 : red giant
#   10: white dwarf
#   11: neutron star
#   12: rogue gas giant
def quadrant_systems (outfile, counts, pnum, chances, anc_mult):
  index_val = 1
  sys_cnt = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

  sys_cnt[5] = pnum.count(5)
  sys_cnt[6] = pnum.count(6)
  sys_cnt[7] = pnum.count(7)
  sys_cnt[8] = pnum.count(8)
  sys_cnt[9] = pnum.count(9)
  sys_cnt[10] = pnum.count(10)

  sys_pct = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

  sys_pct[5] = 5
  sys_pct[6] = 10
  sys_pct[7] = 20
  sys_pct[8] = 35
  sys_pct[9] = 20
  sys_pct[10] = 10

  total = 0
  for c in counts:
    total += c

  outfile.write('Number of System Types    := ' + str(total) + '\n')

  index_val = 0

  # Output Standard #
  i = 0
  while i < counts[1]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Standard ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[1] * (sys_pct[pnum[i - 1]]) / 100) / (sys_cnt[pnum[i - 1]])

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Binary #
  i = 0
  while i < counts[2]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Binary ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[2] * (1) / (counts[2]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Trinary #
  i = 0
  while i < counts[3]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Trinary ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[3] * (1) / (counts[3]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Quaternary #
  i = 0
  while i < counts[4]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Quaternary ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[4] * (1) / (counts[4]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Quintuple #
  i = 0
  while i < counts[5]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Quintuple ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[5] * (1) / (counts[5]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Nebulae #
  i = 0
  while i < counts[6]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Nebulae ' + str(i) + '\n')
    #outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Nebulae 2\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[6] * (1) / (counts[6]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Black Hole #
  i = 0
  while i < counts[7]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Black Hole ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[7] * (1) / (counts[7]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Protostar #
  i = 0
  while i < counts[8]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Protostar ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[8] * (1) / (counts[8]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Red Giant System #
  i = 0
  while i < counts[9]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Red Giant System ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[9] * (1) / (counts[9]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output White Dwarf System #
  i = 0
  while i < counts[10]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := White Dwarf System ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 100) / number of this planet count
    c = (chances[10] * (1) / (counts[10]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Neutron Star System #
  i = 0
  while i < counts[11]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Neutron Star System ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 110) / number of this planet count
    c = (chances[11] * (1) / (counts[11]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  # Output Rogue Gas Giant#
  i = 0
  while i < counts[12]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Rogue Gas Giant ' + str(i) + '\n')

    # (total chance * (percent for this planet count) / 110) / number of this planet count
    c = (chances[12] * (1) / (counts[12]))

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while

  c_rem = 1000 - sum(chances)

  if (c_rem == 0):
    print "Warning: Remaining chance is 0."
  elif (c_rem < 0):
  	print "Warning: Remaining chance less than 0."

  # Output Asteroid Belts#
  i = 0
  while i < counts[-1]:
    i += 1
    index_val += 1

    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Asteroid Belt ' + str(i) + '\n')

    if c_rem > 0:
      c = (c_rem / (counts[-1]))
    else:
      c = 0

    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
  # end while


#  index_val += 1
#  outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Asteroid Belt\n')
#
#  if c > 0:
#    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(c)) + '\n')
#  else:
#    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := 0\n')

  # Write out Expanse if the chance for it is > 0.
  if chances[0] > 0:
    index_val += 1
    outfile.write('Type ' + str(index_val) + ' Name            ' + spaces(index_val) + ' := Expanse\n')
    outfile.write('Type ' + str(index_val) + ' Chance          ' + spaces(index_val) + ' := ' + str(int(chances[0])) + '\n')
# end quadrant_systems()

# Used by the special locations function to randomize system types.
def get_sys_type(chances, counts, sys_pct, sys_cnt_placed):
  name_ar = ['Expanse', 'Standard ', 'Binary ', 'Trinary ', 'Quaternary ', 'Quintuple ', 'Nebulae ', 'Black Hole ', 'Protostar ', 'Red Giant System ', 'White Dwarf System ', 'Neutron Star System ', 'Rogue Gas Giant  ', 'Asteroid Belt']

  # Generate a random number.
  selected_pct = random.randint(1, 1000)

  # Determine which value in chances this corresponds to.
  selected = 1
  tot = 0

  #print 'selected percent: ' + str(selected_pct)

  #print 'chance stuff'

  for i in range(len(chances)):
    #print str(i) + ' : ' + str(chances[i])
    if chances[i] < 1:
      continue

    tot += chances[i]

    if selected_pct < tot:
      selected = i
      break

  to_return = {}

  to_return['type'] = name_ar[selected]

  if counts[selected] > 1:
    to_return['type'] += str(random.randint(1, counts[selected]))

  sys_cnt_placed[selected] += 1

  to_return['cnt'] = sys_cnt_placed

  return to_return
#end get_sys_type()

def validate_coord(valid_coord=[], x=0, y=0, print_check=False):
  bad_coord = False

  # discard any locs that fall off the map.
  if x > 65:
    #print 'Warning, x > 65'
    bad_coord = True
  if x < 1:
    #print 'Warning, x < 0'
    bad_coord = True
  if y > 49:
    #print 'Warning, y > 49'
    bad_coord = True
  if y < 1:
    #print 'Warning, y < 0'
    bad_coord = True

  for c in valid_coord:
    if (abs(x - c['x']) < 2) and (abs(y - c['y']) < 2):
      if print_check:
        print '> checked coord: ' + str(x) + ', ' + str(y)
        print '--> similar coord: ' + str(c['x']) + ', ' + str(c['y'])
        print '----> x-x: ' + str(abs(x - c['x']) < 2)
        print '----> y-y: ' + str(abs(y - c['y']) < 2)
      bad_coord = True

  if bad_coord == False:
    return True
  else:
    return False

# chances array:
#   0 : expanse
#   1 : standard solar systems
#   2 : binary
#   3 : trinary
#   4 : quaternary
#   5 : quintuple
#   6 : nebulae
#   7 : black hole
#   8 : protostar
def quadrant_special_locations (loc_type, loc_num, outfile, counts, pnum, chances, anc_mult):
  index_val = 1
  sys_cnt = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

  sys_cnt[5] = pnum.count(5)
  sys_cnt[6] = pnum.count(6)
  sys_cnt[7] = pnum.count(7)
  sys_cnt[8] = pnum.count(8)
  sys_cnt[9] = pnum.count(9)
  sys_cnt[10] = pnum.count(10)

  sys_pct = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]

  sys_pct[5] = 5
  sys_pct[6] = 10
  sys_pct[7] = 20
  sys_pct[8] = 35
  sys_pct[9] = 20
  sys_pct[10] = 10

  chances2 = []
  total = 0
  for c in chances:
    chances2.append(c)
    total += c

  # Used to track how many of each system type have been placed.
  sys_cnt_placed = []

  counts2 = []
  for c in counts:
    counts2.append(c)
    sys_cnt_placed.append(0)

  chances2.append(1000 - total)
  counts2.append(0)

  # Total locations is potentially limited by what type of placement algorithm
  # we are using.
  loc_total = loc_num
  loop_max = loc_total

  map_center = {'x': 33, 'y': 24}

  valid_coord = []

  if loc_type == 'ring':
    outer_cnt = 48
    mid_cnt = 32
    inner_cnt = 24

    if loc_num > outer_cnt:
      outer_ring = outer_cnt

      if loc_num > mid_cnt + outer_cnt:
        mid_ring = mid_cnt
        inner_ring = loc_num - mid_cnt - outer_cnt
      else:
        mid_ring = loc_num - outer_cnt
        inner_ring = 0
    else:
      outer_ring = loc_num
      mid_ring = 0
      inner_ring = 0

    loc_total = outer_ring + mid_ring + inner_ring
    loop_max = loc_total

    # Generate a list of system locations.
    i = 0
    while i < loop_max:
      i += 1
      index_val += 1

      x = 0
      y = 0

      if index_val <= outer_ring:
        radius = 20

        #theta = 2 * math.pi / loc_num * index_val
        theta = 2 * math.pi / outer_ring * math.floor((i - 1) / 8) + (i % 8) * (math.pi/4)

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print str(index_val) + " in outer"
      elif index_val <= outer_ring + mid_ring:
      	ring_index = index_val - outer_ring

        radius = 16

        theta = 2 * math.pi / mid_ring * math.floor((ring_index - 1) / 8) + (ring_index % 8) * (math.pi/4)

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print str(index_val) + " in inner"
      elif index_val <= outer_ring + mid_ring + inner_ring:
      	ring_index = index_val - outer_ring - mid_ring

        radius = 12

        theta = 2 * math.pi / inner_ring * math.floor((ring_index - 1) / 8) + (ring_index % 8) * (math.pi/4)

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print str(index_val) + " in inner"

      if validate_coord(valid_coord, x, y):
        valid_coord.append({'x': x, 'y': y})

  if loc_type == 'wheel':
    valid_coord = [map_center]

    outer_cnt = 64
    mid_cnt = 48
    inner_cnt = 32

    spokes = 6     # by number of rays
    spoke_length = 3
    spoke_systems = spoke_length * spokes

    if loc_num > spoke_systems + inner_cnt:
      if loc_num > spoke_systems + inner_cnt + mid_cnt:
        if loc_num > spoke_systems + inner_cnt + mid_cnt + outer_cnt:
          inner_ring = inner_cnt
          mid_ring = mid_cnt
          outer_ring = outer_cnt
        else:
          inner_ring = inner_cnt
          mid_ring = mid_cnt
          outer_ring = loc_num - spoke_systems - inner_cnt - mid_cnt
      else:
        inner_ring = inner_cnt
        mid_ring = loc_num - spoke_systems - inner_cnt
        outer_ring = 0

    else:
      inner_ring = loc_num - spoke_systems
      mid_ring = 0
      outer_ring = 0

    loc_total = outer_ring + mid_ring + inner_ring + spoke_systems
    loop_max = loc_total

    # Generate a list of system locations.
    i = 0
    while i < loop_max:
      i += 1

      x = 0
      y = 0

      if i <= spoke_systems:
      	ring_index = int((i - 1) % spokes)
        #print ring_index

        if i <= spokes:
          radius = 12
        elif i <= spokes * (spoke_length - 1):
          radius = 8
        elif i <= spokes * (spoke_length - 0):
          radius = 4

        theta = 2 * math.pi / spokes * math.floor((ring_index - 1))

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print 'rad ' + str(radius) + ': ' + str(x) + ', ' + str(y)

        #print str(i) + " in spokes"

      elif i <= inner_ring + spoke_systems:
      	ring_index = i - spoke_systems

        radius = 16

        theta = 2 * math.pi / inner_ring * math.floor((ring_index - 1) / 8) + (ring_index % 8) * (math.pi/4)

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print str(i) + " in inner mid"

      elif i <= mid_ring + inner_ring + spoke_systems:
      	ring_index = i - inner_ring - spoke_systems

        radius = 20

        theta = 2 * math.pi / mid_ring * math.floor((ring_index - 1) / 8) + (ring_index % 8) * (math.pi/4)

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print str(i) + " in outer"

      #valid_coord.append({'x': x, 'y': y})

      elif i <= outer_ring + mid_ring + inner_ring + spoke_systems:
      	ring_index = i - outer_ring - mid_ring - spoke_systems

        radius = 24

        theta = 2 * math.pi / outer_ring * math.floor((ring_index - 1) / 8) + (ring_index % 8) * (math.pi/4)

        x = int(round(radius * math.cos(theta) + map_center['x']))
        y = int(round(radius * math.sin(theta) + map_center['y']))

        #print str(i) + " in outer"

      #valid_coord.append({'x': x, 'y': y})

      if validate_coord(valid_coord, x, y):
        valid_coord.append({'x': x, 'y': y})

  elif loc_type == 'diamond':
    shell = [1, 8, 16, 24, 32, 40, 48]
    shell_offset = 4

    # Generate a list of system locations.
    i = 0
    while i < loop_max:
      i += 1
      index_val += 1

      x = 0
      y = 0

      j = 0
      prev_s = 0

      #print 'loc ' + str(index_val)

      for s in shell:
        prev_s += s

        if index_val <= prev_s:
          break

        j += 1

      slot = shell[j] - 1 - (prev_s - index_val)

      #map_center = {'x': 0, 'y': 0}

      if shell[j] == 1:
        x = map_center['x']
        y = map_center['y']
      else:
        arm = shell[j] / 4
        offset_amount = (slot % arm * shell_offset / 2)

        if slot < arm:
          x = map_center['x'] + shell_offset * j - offset_amount
          y = map_center['y'] - offset_amount
        elif slot < 2 * arm:
          x = map_center['x'] - shell_offset * j + offset_amount
          y = map_center['y'] + offset_amount
        elif slot < 3 * arm:
          x = map_center['x'] + offset_amount
          y = map_center['y'] + shell_offset * j - offset_amount
        else:
          x = map_center['x'] - offset_amount
          y = map_center['y'] - shell_offset * j + offset_amount

      if validate_coord(valid_coord, x, y):
        valid_coord.append({'x': x, 'y': y})

  elif loc_type in ['spiral', 'flower spiral', 'shell spiral']:
    valid_coord = [map_center]

    print_check = False

    # first attempt, where spirals get connected as WP lines
    param_shell   = {'a': 2,
                     'b': 0.1,
                     'c': math.pi / 8,
                     'phase_list': [0, math.pi / 2, math.pi, 3 * math.pi / 2]
                    }

    # Flower type
    param_flower   = {'a': 1,
                     'b': 0.1,
                     'c': 1,
                     'phase_list': [0, math.pi / 2, math.pi, 3 * math.pi / 2]
                    }

    # discrete spindly arms
    param_spindly = {'a': 1.85,
                     'b': 0.1,
                     'c': 1,
                     'phase_list': [0, math.pi / 2, math.pi, 3 * math.pi / 2]
                    }

    # discrete spindly arms
    param_two_arm = {'a': 1,
                     'b': 0.3,
                     'c': math.pi / 8,
                     'phase_list': [math.pi / 2 + math.pi / 16, math.pi / 2 - math.pi / 16,
                                    3 * math.pi / 2 + math.pi / 16, 3 * math.pi / 2 - math.pi / 16,
                                    math.pi / 2 + 3 * math.pi / 16, math.pi / 2 - 3 * math.pi / 16,
                                    3 * math.pi / 2 + 3 * math.pi / 16, 3 * math.pi / 2 - 3 * math.pi / 16,
                                    math.pi / 2 + 4 * math.pi / 16, math.pi / 2 - 4 * math.pi / 16,
                                    3 * math.pi / 2 + 4 * math.pi / 16, 3 * math.pi / 2 - 4 * math.pi / 16]
                    }

    param = param_two_arm
    factor = 1

    if loc_type == 'shell spiral':
      param = param_shell
      factor = 1
    elif loc_type == 'flower spiral':
      param = param_flower
      factor = 6

      valid_coord.append({'x': map_center['x'] + 4, 'y': map_center['y'] + 3})
      valid_coord.append({'x': map_center['x'] + 4, 'y': map_center['y'] - 3})

      valid_coord.append({'x': map_center['x'] - 4, 'y': map_center['y'] + 3})
      valid_coord.append({'x': map_center['x'] - 4, 'y': map_center['y'] - 3})

      valid_coord.append({'x': map_center['x'] + 6, 'y': map_center['y'] + 1})
      valid_coord.append({'x': map_center['x'] + 6, 'y': map_center['y'] - 1})

      valid_coord.append({'x': map_center['x'] - 6, 'y': map_center['y'] + 1})
      valid_coord.append({'x': map_center['x'] - 6, 'y': map_center['y'] - 1})

      valid_coord.append({'x': map_center['x'] + 1, 'y': map_center['y'] + 4})
      valid_coord.append({'x': map_center['x'] - 1, 'y': map_center['y'] + 4})

      valid_coord.append({'x': map_center['x'] + 1, 'y': map_center['y'] - 4})
      valid_coord.append({'x': map_center['x'] - 1, 'y': map_center['y'] - 4})

    else:
      param = param_two_arm
      factor = 1

      valid_coord.append({'x': map_center['x'] + 4, 'y': map_center['y'] + 3})
      valid_coord.append({'x': map_center['x'] + 4, 'y': map_center['y'] - 3})

      valid_coord.append({'x': map_center['x'] - 4, 'y': map_center['y'] + 3})
      valid_coord.append({'x': map_center['x'] - 4, 'y': map_center['y'] - 3})

      valid_coord.append({'x': map_center['x'] + 6, 'y': map_center['y'] + 1})
      valid_coord.append({'x': map_center['x'] + 6, 'y': map_center['y'] - 1})

      valid_coord.append({'x': map_center['x'] - 6, 'y': map_center['y'] + 1})
      valid_coord.append({'x': map_center['x'] - 6, 'y': map_center['y'] - 1})

      valid_coord.append({'x': map_center['x'] + 1, 'y': map_center['y'] + 4})
      valid_coord.append({'x': map_center['x'] - 1, 'y': map_center['y'] + 4})

      valid_coord.append({'x': map_center['x'] + 1, 'y': map_center['y'] - 4})
      valid_coord.append({'x': map_center['x'] - 1, 'y': map_center['y'] - 4})

    # Make the difference between t0 and t1 decrease as t gets larger
    t_vals = [3]
    for j in range(1, 50):
      t_vals.append(t_vals[j-1] + (100 - t_vals[j-1]) * 0.01)

    #print 't_vals: ' + str(t_vals)

    generate_partner = False
    partner_angle = 3 * math.pi / 180

    for phase in param['phase_list']:
      #for t in range(1, 100):
      for t in t_vals:
        #t0 = t * random.choice([0.9, 0.95, 1.0, 1.05, 1.1])
        t0 = t
        t1 = t * param['c']

        x = round(param['a'] * math.exp(param['b'] * t0) * math.cos(t1 + phase) + map_center['x'])
        y = round(param['a'] * math.exp(param['b'] * t0) * math.sin(t1 + phase) + map_center['y'])

        if generate_partner == True:
          x1 = round(param['a'] * math.exp(param['b'] * t0) * math.cos(t0 + phase + partner_angle) + map_center['x'])
          y1 = round(param['a'] * math.exp(param['b'] * t0) * math.sin(t0 + phase + partner_angle) + map_center['y'])

        #x1 = x - 2
        #y1 = y - 2

        bad_coord = False
        bad_coord1 = False

        # discard any locs that fall off the map.
        if x > 65:
          #print 'Warning, x > 65'
          bad_coord = True
        if x < 1:
          #print 'Warning, x < 0'
          bad_coord = True
        if y > 49:
          #print 'Warning, y > 49'
          bad_coord = True
        if y < 1:
          #print 'Warning, y < 0'
          bad_coord = True

        if generate_partner == True:
          if x1 > 65:
            #print 'Warning, x > 65'
            bad_coord1 = True
          if x1 < 1:
            #print 'Warning, x < 0'
            bad_coord1 = True
          if y1 > 49:
            #print 'Warning, y > 49'
            bad_coord1 = True
          if y1 < 1:
            #print 'Warning, y < 0'
            bad_coord1 = True

        for c in valid_coord:
          if (abs(x - c['x']) < 2) and (abs(y - c['y']) < 2):
            if print_check:
              print '> checked coord: ' + str(x) + ', ' + str(y)
              print '--> similar coord: ' + str(c['x']) + ', ' + str(c['y'])
              print '----> x-x: ' + str(abs(x - c['x']) < 2)
              print '----> y-y: ' + str(abs(y - c['y']) < 2)
            bad_coord = True

          if generate_partner == True:
            if (abs(x1 - c['x']) < 2) and (abs(y1 - c['y']) < 2):
              bad_coord1 = True

        if bad_coord == False:
          valid_coord.append({'x': x, 'y': y})

        if generate_partner == True:
          if (abs(x1 - x) < 2) and (abs(y1 - y) < 2):
            bad_coord1 = True

          if bad_coord1 == False:
            valid_coord.append({'x': x1, 'y': y1})

        #print 't: ' + str(t) + ' coord: ' + str(x) + ', ' + str(y)

    if loc_type == 'spiral':
      valid_coord.append({'x': map_center['x'] + 8, 'y': map_center['y'] + 1})
      valid_coord.append({'x': map_center['x'] + 8, 'y': map_center['y'] - 1})

      valid_coord.append({'x': map_center['x'] - 8, 'y': map_center['y'] + 1})
      valid_coord.append({'x': map_center['x'] - 8, 'y': map_center['y'] - 1})

      valid_coord.append({'x': map_center['x'] + 6, 'y': map_center['y'] - 3})
      valid_coord.append({'x': map_center['x'] - 6, 'y': map_center['y'] + 3})


    loc_total = len(valid_coord)
    loop_max = loc_total

    if loop_max % factor > 0:
      loop_max +=  factor - loop_max % factor

  loc_total = len(valid_coord)
  loop_max = loc_total

  print '* ' + loc_type + ' ' + str(loc_total)

  #print "loc_num: " + str(loc_num)
  #print "outer_ring: " + str(outer_ring)
  #print "inner_ring: " + str(inner_ring)

  index_val = 0

  outfile.write('Number of Locations       := ' + str(loc_total) + '\n')

  #print 'chances '
  #print chances
  #print chances2

  # Output Standard #
  i = 0
  while i < loop_max:
    i += 1
    index_val += 1

    #print '------------------------------------------------------------'
    #print 'Location ' + str(index_val)

    sys_type_ret = get_sys_type(chances2, counts2, sys_pct, sys_cnt_placed)
    sys_type = sys_type_ret['type']
    sys_cnt_placed = sys_type_ret['cnt']

    #print sys_type
    #print sys_cnt_placed

    x = 0
    y = 0


    if loc_type in ['spiral', 'flower spiral', 'shell spiral']:
      n = i - 1
      ind = (factor * n) % (loop_max) + (factor * n) / loop_max
    else:
      ind = i - 1

    if ind > len(valid_coord) - 1:
      index_val -= 1
      continue

    c = valid_coord[ind]
    x = int(c['x'])
    y = int(c['y'])

    if x == map_center['x'] and y == map_center['y']:
      sys_type = 'Black Hole 1'

    #print 'shell: ' + str(j) + ' (' + str(shell[j]) + '); slot: ' + str(slot) + '; loc: ' + str(x) + ', ' + str(y) + '\n'

    outfile.write('Location ' + str(index_val) + ' System Type ' + spaces(index_val) + ' := ' + sys_type + '\n')
    outfile.write('Location ' + str(index_val) + ' Position X  ' + spaces(index_val) + ' := ' + str(x) + '\n')
    outfile.write('Location ' + str(index_val) + ' Position Y  ' + spaces(index_val) + ' := ' + str(y) + '\n')
# end quadrant_special_locations()
